"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.use = void 0;
const controller_1 = require("../metadata/controller");
/**
 * Applies middleware to the entire controller.
 * @param middleware The middleware to apply to the controller.
 */
function use(...middleware) {
    return (target) => {
        var _a, _b;
        const metadata = (_a = controller_1.getControllerMetadata(target)) !== null && _a !== void 0 ? _a : { middleware: [] };
        controller_1.appendControllerMetadata(target, {
            middleware: [...((_b = metadata.middleware) !== null && _b !== void 0 ? _b : []), ...middleware],
        });
    };
}
exports.use = use;
//# sourceMappingURL=use.js.map