"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const use_1 = require("./use");
const metadata_1 = require("../metadata");
describe("Middleware Decorators", function () {
    describe("@use on class", function () {
        it("sets the controller metadata", function () {
            let TestClass = class TestClass {
            };
            TestClass = __decorate([
                use_1.use((req, res, next) => next())
            ], TestClass);
            expect(metadata_1.getControllerMetadata(TestClass)).toBeDefined();
        });
        it("adds the middleware to the metadata", function () {
            const middleware1 = (req, res, next) => next();
            const middleware2 = (req, res, next) => next();
            let TestClass = class TestClass {
            };
            TestClass = __decorate([
                use_1.use(middleware1, middleware2)
            ], TestClass);
            expect(metadata_1.getControllerMetadata(TestClass).middleware).toEqual([
                middleware1,
                middleware2,
            ]);
        });
        it("appends the middleware to existing metadata", function () {
            const middleware1 = (req, res, next) => next();
            const middleware2 = (req, res, next) => next();
            let TestClass = class TestClass {
            };
            TestClass = __decorate([
                use_1.use(middleware1),
                use_1.use(middleware2)
            ], TestClass);
            expect(metadata_1.getControllerMetadata(TestClass).middleware).toEqual([
                middleware2,
                middleware1,
            ]);
        });
    });
});
//# sourceMappingURL=use.spec.js.map