"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.appendControllerMetadata = exports.setControllerMetadata = exports.getControllerMetadata = void 0;
const lodash_1 = require("lodash");
const create_symbol_1 = __importDefault(require("../create-symbol"));
const ControllerMetadataSymbol = create_symbol_1.default("controller-metadata");
function getControllerMetadata(controller) {
    return controller[ControllerMetadataSymbol] || undefined;
}
exports.getControllerMetadata = getControllerMetadata;
function setControllerMetadata(controller, metadata) {
    controller[ControllerMetadataSymbol] = metadata;
}
exports.setControllerMetadata = setControllerMetadata;
function appendControllerMetadata(controller, metadata) {
    if (!controller[ControllerMetadataSymbol]) {
        controller[ControllerMetadataSymbol] = {};
    }
    lodash_1.merge(controller[ControllerMetadataSymbol], metadata);
}
exports.appendControllerMetadata = appendControllerMetadata;
//# sourceMappingURL=controller.js.map